application/core/models.py
from dataclasses import dataclass, field
from typing import List


@dataclass
class Problem:
    id: int
    theme: str
    theme_id: int
    title: str
    description: str
    last_update_time: str


@dataclass
class ProblemListElement:
    id: int
    title: str


@dataclass
class Theme:
    id: int
    title: str


@dataclass
class File:
    name: str
    value: str


@dataclass
class Submission:
    id: int
    problem_id: int
    status: str
    files: List[File] = field(default_factory=list)

application/__init__.py
from flask import Flask


def create_app():
    """Create Flask application."""
    app = Flask(__name__, instance_relative_config=False)
    app.config.from_json('config.json')

    with app.app_context():
        # Import application parts
        from application.web import web as web_bp

        # Register Blueprints
        app.register_blueprint(web_bp)

        return app

application/web/__init__.py
from flask import Blueprint

web = Blueprint('web', __name__)

from . import routes

application/web/routes.py
from flask import render_template, send_from_directory, abort, request, flash, redirect, url_for

from application.core.services import ProblemService, ThemeService, SubmissionService
from application.web import web


@web.route('/favicon.ico')
def favicon():
    return send_from_directory("static", 'favicon.ico', mimetype='image/vnd.microsoft.icon')


@web.route('/', methods=['GET'])
@web.route('/index', methods=['GET'])
def index():
    return redirect(url_for('web.themes'))


@web.route('/themes', methods=['GET'])
def themes():
    themes = ThemeService.get_all()
    if not themes:
        abort(404)
    return render_template('themes.html', themes=themes)


@web.route('/themes/<theme_id>/problems', methods=['GET'])
def problems(theme_id):
    theme = ThemeService.get_by_id(theme_id)
    problems = ProblemService.get_by_theme_id(theme_id)
    if not problems:
        abort(404)
    return render_template('problems.html', problems=problems, theme=theme)


@web.route('/problems/<problem_id>', methods=['GET', 'POST'])
def problem(problem_id):
    problem = ProblemService.get_by_id(problem_id)
    submissions = SubmissionService.get_all(problem_id)
    if not problem:
        abort(404)
    if request.method == 'POST':
        flash('Решение успешно отправлено', category='success')
    return render_template('problem.html', problem=problem, submissions=submissions)


@web.route('/login', methods=['GET', 'POST'])
def login():
    return render_template('login.html')


@web.route('/signup', methods=['GET', 'POST'])
def signup():
    return render_template('signup.html')


@web.errorhandler(404)
def error_404(error_info):
    return render_template('error_page.html', title='404', error_info=error_info, error_code='404',
                           error_text='страница не найдена'), 404


@web.errorhandler(500)
@web.errorhandler(Exception)
def error_500(error_info):
    return render_template('error_page.html', title='500', error_info=error_info, error_code='500',
                           error_text='внутренняя ошибка сервера'), 500

application/templates/base.html
<!doctype html>
<html lang="ru">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- CSS -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
          integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static',filename='style.css') }}">

    <!-- Block HEADER -->
    {% block header %}{% endblock %}

    <title>Cattester</title>
</head>
<body>
<div class="container-fluid ">
    <div class="row form-group">
        <div class="col-lg-12 px-0">
            <nav class="navbar navbar-light bg-light navbar-expand-lg border justify-content-between">
                <a class="navbar-brand pr-5" href="{{ url_for('web.index') }}">
                    <img src="{{ url_for('static', filename='paw.png') }}" width="32" height="32"
                         class="d-inline-block align-top" alt=""/>
                    Cattester
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
                        aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarNav">
                    <ol class="breadcrumb bg-light ml-lg-auto mx-md-0 mb-0 px-0">
                        <!-- Block NAVIGATION -->
                        {% block navigation %}{% endblock %}
                    </ol>

                    <form class="form-inline ml-lg-auto mx-md-0">
                        <input class="form-control mr-sm-2" type="search" placeholder="Поиск..." aria-label="Search">
                    </form>

                    <ul class="navbar-nav ">
                        <li class="nav-item"><a class="nav-link" href="{{ url_for('web.login') }}">Вход</a></li>
                        <li class="nav-item"><a class="nav-link" href="{{ url_for('web.signup') }}">Регистрация</a></li>
                    </ul>
                </div>
            </nav>
        </div>
    </div>
    <div class="row form-group">
        <!-- Block CONTENT -->
        {% block content %}{% endblock %}
    </div>
</div>


<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
        integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
        crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.min.js"
        integrity="sha384-w1Q4orYjBQndcko6MimVbzY0tgp4pWB4lZ7lr30WKz0vr/aWKhXdBNmNb5D92v7s"
        crossorigin="anonymous"></script>

<!-- Block SCRIPT -->
{% block script %}{% endblock %}

</body>
</html>

application/templates/error_page.html
{% extends "base.html" %}

<!---------- Content ----------->
{% block content %}

    <div class="col-sm-8 offset-sm-2">
        <div class="jumbotron">
            <h3>Ошибка {{ error_code }}: {{ error_text }}</h3>
            <hr class="my-3">
            {% if content %}
                <p>{{ content }}</p>
            {% else %}
                <p>Что-то пошло не так :с</p>
                <br>
                <p>
                    <a class="btn btn-sm btn-outline-dark" data-toggle="collapse" href="#collapseDevInfo" role="button"
                       aria-expanded="false" aria-controls="collapseDevInfo">
                        Подробнее об ошибке...
                    </a>
                </p>
                <div class="collapse" id="collapseDevInfo">
                    <div class="card card-body">
                        {{ error_info }}
                    </div>
                </div>
            {% endif %}
        </div>
    </div>

{% endblock %}

application/templates/index.html
{% extends "base.html" %}


<!---------- Content ----------->
{% block content %}
    <div class="col-sm-8 offset-sm-2">
        <div class="jumbotron">
            <h1 class="display-4">Добро пожаловать!</h1>
            <hr class="my-4">
            <p class="mb-3">Давайте порешаем задачки.</p>
        </div>
    </div>
{% endblock %}

application/templates/login.html
{% extends "base.html" %}

<!---------- Content ----------->
{% block content %}
    <div class="col-lg-4 offset-lg-4">
        <div class="row">
            <div class="col">
                <div class="container border bg-light rounded p-4">
                    <form method="POST">
                        <div class="md-form form-group bmd-form-group pb-2">
                            <h3 class="text-center font-weight-light">Вход</h3>
                        </div>
                        <div class="md-form form-group bmd-form-group">
                            <input required class="form-control" id="email" name='email' placeholder="E-mail"
                                   type="text">
                        </div>
                        <div class="md-form form-group bmd-form-group pb-3">
                            <input required class="form-control" id="password" name='password' placeholder="Пароль"
                                   type="password">
                        </div>
                        <div class="md-form form-group bmd-form-group">
                            <button type="submit" class="btn btn-raised btn-dark mr-2">Войти</button>
                            <a href="{{ url_for('web.signup') }}"
                               class="btn btn-outline-secondary">Зарегистрироваться</a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

application/templates/problem.html
{% extends "base.html" %}
<!---------- Navigation ----------->
{% block navigation %}
    <li class="breadcrumb-item text-capitalize">
        <a href="{{ url_for('web.problems', theme_id=problem.theme_id) }}" class="text-dark">
            {{ problem.theme }}
        </a>
    </li>
    <li class="breadcrumb-item text-capitalize active">{{ problem.title }}
        <span class="badge badge-secondary ml-2" style="line-height: inherit">Не решена</span>
    </li>
{% endblock %}

<!---------- Content ----------->
{% block content %}
    <div class="col-lg-8 offset-lg-2">
        <div class="container p-0">
            <ul class="nav nav-tabs" role="tablist">
                <li class="nav-item" role="presentation">
                    <a class="nav-link active px-4" id="description-tab" data-toggle="tab" href="#description"
                       role="tab"
                       aria-controls="description" aria-selected="true">Описание</a>
                </li>
                <li class="nav-item ml-2" role="presentation">
                    <a class="nav-link" id="submissions-tab" data-toggle="tab" href="#submissions" role="tab"
                       aria-controls="submissions" aria-selected="false">Посылки</a>
                </li>
            </ul>
            <div class="container bg-light border border-top-0 p-0 rounded-bottom tab-content">
                <div class="tab-pane fade show active p-4" id="description" role="tabpanel"
                     aria-labelledby="description-tab">
                    {{ problem.description|safe }}
                </div>
                <div class="tab-pane fade" id="submissions" role="tabpanel" aria-labelledby="submissions-tab">
                    <div class="accordion">
                        {% for submission in submissions %}
                            <div class="card">
                                <div class="card-header" id="headingThree{{ loop.revindex }}">
                                    <button class="btn btn-link btn-block d-flex justify-content-between" type="button"
                                            data-toggle="collapse" data-target="#collapseThree{{ loop.revindex }}"
                                            aria-expanded="false" aria-controls="collapseThree{{ loop.revindex }}">
                                        Посылка #{{ loop.revindex }}
                                        <span class="badge badge-success mt-1">
                                            {{ submission.status }}
                                        </span>
                                    </button>
                                </div>
                                <div id="collapseThree{{ loop.revindex }}"
                                     class="collapse {% if loop.index0 == 0 %}show{% endif %}"
                                     aria-labelledby="headingThree{{ loop.revindex }}" data-parent="#submissions">
                                    <div class="card-body">
                                        {% for file in submission.files %}
                                            <button type="button" class="btn btn-light btn-sm" data-toggle="modal"
                                                    data-target="#fileModal{{ submission.id }}{{ loop.index }}">
                                                {{ file.name }}
                                            </button>

                                            <div class="modal fade"
                                                 id="fileModal{{ submission.id }}{{ loop.index }}" tabindex="-1"
                                                 aria-labelledby="fileModalLabel" aria-hidden="true">
                                                <div class="modal-dialog modal-dialog-scrollable modal-xl">
                                                    <div class="modal-content">
                                                        <div class="modal-header">
                                                            <h5 class="modal-title"
                                                                id="fileModalLabel">{{ file.name }}</h5>
                                                            <button type="button" class="close" data-dismiss="modal"
                                                                    aria-label="Close">
                                                                <span aria-hidden="true">&times;</span>
                                                            </button>
                                                        </div>
                                                        <div class="modal-body">
                                                            <code class="text-dark">
                                                                {{ file.value }}
                                                            </code>
                                                        </div>
                                                        <div class="modal-footer">
                                                            <button type="button" class="btn btn-sm btn-secondary"
                                                                    data-dismiss="modal">Закрыть
                                                            </button>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                </div>
            </div>
        </div>

        <div class="container border bg-light rounded p-4 mt-4">
            <form method="post" class="needs-validation" novalidate>
                <div class="md-form form-group bmd-form-group">
                    <h5 class="text-center font-weight-light">Отправка решения</h5>
                </div>
                <div class="md-form form-group bmd-form-group">
                    <label for="environment">Язык</label>
                    <select class="form-control custom-select" id="environment" required>
                        <option selected>Python</option>
                        <option>С++</option>
                        <option>С#</option>
                    </select>
                    <div class="invalid-feedback">
                        Необходимо выбрать язык.
                    </div>
                </div>
                <div class="md-form form-group bmd-form-group pb-3">
                    <label for="files">Файлы</label>
                    <div class=" custom-file">
                        <input type="file" class=" custom-file-input" id="files" multiple required>
                        <label for="files" class="custom-file-label" data-browse="Обзор...">Выберите файлы</label>
                        <div class="invalid-feedback">
                            Необходимо выбрать один или несколько файлов.
                        </div>
                    </div>
                </div>
                <button class="btn btn-dark" type="submit">Отправить</button>
            </form>
        </div>

        {% for type, message in get_flashed_messages(with_categories=True) %}
            <div class="container alert alert-{{ type }} fade show rounded-lg my-3" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                {{ message }}
            </div>
        {% endfor %}

    </div>
{% endblock %}


<!---------- Script ----------->
{% block script %}

    <script>
        $(document).ready(function () {
            setTimeout(function () {
                $(".alert").alert('close');
            }, 3000);
        });
    </script>

    <script src="https://cdn.jsdelivr.net/npm/bs-custom-file-input/dist/bs-custom-file-input.min.js"></script>
    <script>bsCustomFileInput.init()</script>

    <script>
        // Bootstrap form validation
        (function () {
            'use strict';
            window.addEventListener('load', function () {
                var forms = document.getElementsByClassName('needs-validation');
                var validation = Array.prototype.filter.call(forms, function (form) {
                    form.addEventListener('submit', function (event) {
                        if (form.checkValidity() === false) {
                            event.preventDefault();
                            event.stopPropagation();
                        }
                        form.classList.add('was-validated');
                    }, false);
                });
            }, false);
        })();
    </script>

{% endblock %}

application/templates/problems.html
{% extends "base.html" %}
<!---------- Navigation ----------->
{% block navigation %}
    <li class="breadcrumb-item text-capitalize">{{ theme.title }}</li>
{% endblock %}

<!---------- Content ----------->
{% block content %}
    <div class="col-lg-8 offset-lg-2">
        <div class="row">
            <div class="col-lg-8">
                {% for problem in problems %}
                    <div class="container-lg border bg-light rounded p-4 mb-4">
                        <span class="text-muted"><small>#{{ problem.id }}</small></span>
                        <div class="d-flex w-100">
                            <a href="{{ url_for('web.problem', problem_id=problem.id) }}" class="text-dark text-decoration-none flex-grow-1">
                                <h5 class="font-weight-light text-capitalize">{{ problem.title }}</h5>
                            </a>
                            <a href="{{ url_for('web.problem', problem_id=problem.id) }}"
                               class="btn btn-lg btn-outline-success align-self-center">Решить
                            </a>
                        </div>

                        <span class="badge badge-pill badge-secondary text-capitalize">Тег</span>
                    </div>
                {% endfor %}
            </div>
            <div class="col-sm-4">
                <div class="container-lg border bg-light rounded p-4">
                    <h5 class="text-center font-weight-light">Фильтры</h5>
                    <div class="form-group form-check">
                        <input type="checkbox" class="form-check-input" id="exampleCheck1">
                        <label class="form-check-label" for="exampleCheck1">Решенные</label>
                    </div>
                    <div class="form-group form-check">
                        <input type="checkbox" class="form-check-input" id="exampleCheck2">
                        <label class="form-check-label" for="exampleCheck2">Нерешенные</label>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

application/templates/signup.html
{% extends "base.html" %}

<!---------- Content ----------->
{% block content %}
    <div class="col-sm-6 offset-sm-3">
        <div class="row">
            <div class="col">
                <div class="container rounded-lg p-3">
                    Not implemented yet
                </div>
            </div>
        </div>
    </div>
{% endblock %}

application/templates/themes.html
{% extends "base.html" %}
<!---------- Navigation ----------->
{% block navigation %}
    <li class="breadcrumb-item">Список тем</li>
{% endblock %}

<!---------- Content ----------->
{% block content %}
    <div class="col-lg-8 offset-lg-2">
        {% for theme in themes %}
            <div class="container-lg border bg-light rounded p-4 mb-4">
                <div class="d-flex w-100">
                    <a href="{{ url_for('web.problems', theme_id=theme.id) }}" class="text-decoration-none flex-grow-1">
                        <span class="text-muted"><small>#{{ theme.id }}</small></span>
                        <h5 class="font-weight-light text-dark text-capitalize">{{ theme.title }}</h5>
                    </a>
                    <a href="{{ url_for('web.problems', theme_id=theme.id) }}" class="btn btn-lg btn-outline-dark align-self-center">
                        Перейти к задачам
                    </a>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}